//---------------------------------------------------------------------------

#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include <stdio.h>
#include "Settings.h"
#include "Krata.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cmb1Change(TObject *Sender)
{
        //int id = cmb1->Items->Count;
        {
                G[0].SetRank(rzad);
                //G[0].SetPoly(cmb1->Items->Strings[cmb1->ItemIndex]);
                G[0].SetPoly("1+x+x^2");
                G[1].SetRank(rzad);
                G[1].SetPoly("1+x^2");
                //ShowMessage(G[0].CalcOutput("111"));

                /*
                rzad = 3;
                TState s;
                s.SetRank(rzad);
                AnsiString str = "";
                AnsiString input = "";
                for(int i=0;i<pow(2.0,rzad);i++)
                {
                        s.Init(i);
                        for(int j=0;j<2;j++)
                        {
                                input = IntToStr(j) + s.GetState();
                                str += IntToStr(i) + "::" + IntToStr(j) + "     " + s.Trans(j) + "::" + G[0].CalcOutput(input)+G[1].CalcOutput(input)+"\n";
                        }
                }
                ShowMessage(str);

                s.Init(3);
                s.Trans(1);
                */
        }
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::chk1Click(TObject *Sender)
{
/*
        if(chk1->Checked)
                cmb1->Enabled = true;
                //wgrywanie wielomianow
        else
        {
                cmb1->Items->Text = "..nieaktywne..";
                cmb1->ItemIndex = 0;
                cmb1->Enabled = false;
        }
*/
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::SpeedButton2Click(TObject *Sender)
{
        frmKrata->Show();
/*
        img->Canvas->Refresh();
        TState *s = new TState[16];
        int top, left=30;
        int step = 20;
        for(int i=0;i<4;i++)
        {
                s[i].Init(i,2);
                top = step + i*step;
                for(int j=0;j<2;j++)
                {
                        img->Canvas->MoveTo(left, top);
                        img->Canvas->TextOutA(left-25, top, s[i].GetState());
                        int c = s[i].Next(j);
                        if(j==0)
                        {
                                img->Canvas->Pen->Color = clRed;
                                img->Canvas->Pen->Style = psSolid;
                        }
                        if(j==1)
                        {
                                img->Canvas->Pen->Color = clBlue;
                                img->Canvas->Pen->Style = psDot;
                        }
                        img->Canvas->LineTo(left + 200, step+c*step);
                        img->Canvas->TextOutA(left+200, step/2+c*step, s[i].TransStr(j));

                }
        }

*/
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::edSeqKeyPress(TObject *Sender, char &Key)
{
        int z = Key;
        if(Key!='1' && Key!='0' && z!= 8 && z!=13)
                Key = NULL;

        if(Key==13)
        {
                if(edSeq->Text.Length()<2) edSeq->Text = "01";
                btnStepClick(Sender);
        }
}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::SpeedButton4Click(TObject *Sender)
{
        frmSettings->Show();
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::FormShow(TObject *Sender)
{
        cmbOff->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnStepClick(TObject *Sender)
{


        // stworzenie kraty i wykonanie algorytmu



        if(pos==0)
        {
                Trellis.Create(rzad,poly_count,p, img, StrToInt(edSnr->Text));
                Trellis.SetInputSeq(edSeq->Text);
                Trellis.SetOff(StrToInt(cmbOff->Items->Strings[cmbOff->ItemIndex]));
                Trellis.Calc();
                Trellis.Disp(pos, StrToInt(cmbOff->Items->Strings[cmbOff->ItemIndex]));
                pos++;
                cmbOff->Enabled = false;
                edSeq->Enabled = false;
                edSnr->Enabled = false;
        }
        else
        {
                Trellis.Disp(pos, StrToInt(cmbOff->Items->Strings[cmbOff->ItemIndex]));
                pos++;
                if(pos>edSeq->Text.Length())
                {
                        pos--;
                        Timer->Enabled = false;
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
        randomize();
        pos = 0;
        TIniFile *ini;
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        rzad = ini->ReadInteger("Model", "rzad", 2);
        poly_count = ini->ReadInteger("Model", "poly_count", 2);
        timer_count = ini->ReadInteger("Timer", "czas", 3);
        p = new AnsiString[poly_count];                      // ile wielomianow

        // inicjacja wielomianw
        for(int i=0;i<poly_count;i++)
                p[i] = ini->ReadString("w"+IntToStr(i), "item", "1");

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnNewClick(TObject *Sender)
{

        TIniFile *ini;
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        rzad = ini->ReadInteger("Model", "rzad", 2);
        poly_count = ini->ReadInteger("Model", "poly_count", 2);
        timer_count = ini->ReadInteger("Timer", "czas", 3);
        p = new AnsiString[poly_count];                      // ile wielomianow

        // inicjacja wielomianw
        for(int i=0;i<poly_count;i++)
                p[i] = ini->ReadString("w"+IntToStr(i), "item", "1");

        cmbOff->Enabled = true;
        edSeq->Enabled = true;
        edSnr->Enabled = true;
        edSeq->SetFocus();
        pos = 0;
}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::SpeedButton8Click(TObject *Sender)
{
        Timer->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::TimerTimer(TObject *Sender)
{
        btnStepClick(Sender);
        if(pos>0) Timer->Interval = 1000*timer_count;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::edSnrKeyPress(TObject *Sender, char &Key)
{
        int z = Key;
        if(!(z>=48 && z<=57) && z!= 8 && z!=13)
                Key = NULL;
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::SpeedButton5Click(TObject *Sender)
{
        Timer->Enabled = false;        
}
//---------------------------------------------------------------------------

