//---------------------------------------------------------------------------

#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "Settings.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmSettings *frmSettings;
//---------------------------------------------------------------------------
__fastcall TfrmSettings::TfrmSettings(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::FormCreate(TObject *Sender)
{
        if(!FileExists(ChangeFileExt( Application->ExeName, ".INI" )))
        {
                FILE *plik;
                plik = fopen(ChangeFileExt( Application->ExeName, ".INI" ).c_str(),"w");
                delete plik;

                TIniFile *ini;
                ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

                ini->WriteInteger( "Model", "rzad", 2 );
                ini->WriteInteger( "Model", "poly_count", 3 );

                ini->WriteString( "0", "1", "1" );

                ini->WriteString( "1", "x", "x" );
                ini->WriteString( "1", "1+x", "1+x" );

                ini->WriteString( "2", "x^2", "x^2" );
                ini->WriteString( "2", "1+x^2", "1+x^2" );
                ini->WriteString( "2", "x+x^2", "x+x^2" );
                ini->WriteString( "2", "1+x+x^2", "1+x+x^2" );

                ini->WriteInteger("Timer", "czas", 5);

                delete ini;
        }

        TIniFile *ini;
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        rzad = ini->ReadInteger("Model", "rzad", 2);
        cmbRzad->ItemIndex = rzad-2;

        poly_count = ini->ReadInteger("Model", "poly_count", 2);
        cmbPoly->ItemIndex = poly_count-2;

        timer_count = ini->ReadInteger("Timer", "czas", 5);
        cmbTimer->ItemIndex = timer_count-1;



        CreatePolyFields(poly_count, poly_count);
        delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::SpeedButton1Click(TObject *Sender)
{
        TIniFile *ini;
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );


        ini->WriteInteger( "Model", "rzad", StrToInt(cmbRzad->Items->Strings[cmbRzad->ItemIndex]) );
        ini->WriteInteger( "Model", "poly_count", StrToInt(cmbPoly->Items->Strings[cmbPoly->ItemIndex]) );
        ini->WriteInteger("Timer", "czas", StrToInt(cmbTimer->Items->Strings[cmbTimer->ItemIndex]));

        for(int i=0;i<poly_count;i++)
        {
                ini->WriteString("w"+IntToStr(i), "item", cmb[i]->Text);
                ini->WriteInteger("w"+IntToStr(i), "idx", cmb[i]->ItemIndex);
        }

        Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::cmbRzadChange(TObject *Sender)
{
        rzad = StrToInt(cmbRzad->Items->Strings[cmbRzad->ItemIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::cmbPolyChange(TObject *Sender)
{
        int old_count = poly_count;
        poly_count = StrToInt(cmbPoly->Items->Strings[cmbPoly->ItemIndex]);

        if(old_count!=poly_count)
        {
                for(int i=0;i<old_count;i++)
                {
                        delete cmb[i];
                        delete lab[i];
                }

                CreatePolyFields(poly_count, old_count);
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::SpeedButton2Click(TObject *Sender)
{
        Close();        
}
//---------------------------------------------------------------------------

