//---------------------------------------------------------------------------

#ifndef SettingsH
#define SettingsH
//---------------------------------------------------------------------------
#include <stdio.h>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TfrmSettings : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TGroupBox *GroupBox3;
        TLabel *Label6;
        TLabel *Label7;
        TComboBox *cmbRzad;
        TComboBox *cmbPoly;
        TGroupBox *grpPoly;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton2;
        TTabSheet *TabSheet2;
        TGroupBox *GroupBox1;
        TLabel *Label1;
        TComboBox *cmbTimer;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall cmbRzadChange(TObject *Sender);
        void __fastcall cmbPolyChange(TObject *Sender);
        void __fastcall SpeedButton2Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TfrmSettings(TComponent* Owner);
        int rzad;
        int poly_count;
        int timer_count;

        TComboBox **cmb;
        TLabel **lab;

        void CreatePolyFields(int count, int old_count);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmSettings *frmSettings;
//---------------------------------------------------------------------------

void TfrmSettings::CreatePolyFields(int count, int old_count)
{
        int top = 25;
        int left = 60;
        int w = 145, h = 20;


        TIniFile *ini;
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        cmb = new TComboBox*[count];
        lab = new TLabel*[count];

        for(int i=0;i<count;i++)
        {
                //cmb[i]->
                cmb[i] = new TComboBox(grpPoly);
                cmb[i]->Parent = grpPoly;
                cmb[i]->Top = top;
                cmb[i]->Left = left;
                cmb[i]->Width = w;
                cmb[i]->Height = h;
                cmb[i]->Style = csDropDownList;
                cmb[i]->Visible = true;

                lab[i] = new TLabel(grpPoly);
                lab[i]->Parent = grpPoly;
                lab[i]->Left = left-40;
                lab[i]->Top = top+3;

                lab[i]->Caption = "g(" + IntToStr(i+1) + ") =";

                top += 25;
        }

        TStringList* MyList = new TStringList();

        //int ile = StrToInt(cmbRzad->Items->Strings[cmbRzad->ItemIndex]);
        for(int i=0;i<=rzad;i++)
        {
                ini->ReadSection(IntToStr(i),MyList);
                for(int j=0;j<count;j++)
                        cmb[j]->Items->AddStrings(MyList);
        }

        for(int i=0;i<count;i++)
                cmb[i]->ItemIndex = ini->ReadInteger("w"+IntToStr(i), "idx", 0);

        delete ini;
}

#endif


